# 窃电漏电用户的发现
- 背景
	- 在研究这个项目之前我也在想，为什么这种领域需要数据挖掘？其实你若愿意去发现，你会发现，数据挖掘无处不在。
	- 为什么选择数据分析与挖掘技术？原因当然是之前处理方式的不合理。
    
		| 方式 | 不合理之处 |
   		| :--- | :--- |
   		| 定期巡检、定期检查电表、用户举报 | 对人的依赖太高，容错率低 。|
   		| 营销稽查人员、用电检查人员利用计量异常报警功能和电能量数据查询功能开展在线监控，采集异常信息，建立数据分析模型| 由于终端误报，存在数据可靠性问题。 |
	- 目前存在的分析模型，各输入指标权重是由人定的，这是含有主观臆断的，存在明显缺陷，实施效果不尽如人意。
	- 目前的自动化系统可以采集相关信息，通过这些信息提取漏电用户的特征，构建识别模型，就能做到自动检查。
   
- 分析过程和方法
	- 数据获取
		- 数据集已给出,很多时候分析人员拿到的不是数据集信息而是需要处理的原始数据如多个文档、多个图片，处理方法各不相同。
	- 数据探索
		- 分布分析（主要目的是筛选分析对象类别）
		- 周期性分析（查看正常用户和非正常用户数据周期变化比对）
	- 数据预处理
		- 过滤不可能窃电用户，剔除之
		- 过滤特殊时间点数据（节假日，数据不合理是正常的）
		- 缺失值处理，使用拉格朗日插值法插值（注意，这里直接删除会造成周期性分析不合理）
	- 数据挖掘建模
		- 典型的给出特征和分类标签，对新的数据特征进行分类（打标签）
		- 使用LM神经网络和CART决策树进行模型搭建
	- 后续处理
		- 根据用户数据实时分析用户特征，也就是模型的实际使用。
- 补充说明
	- 使用两种建模方式（LM神经网络和CART决策树）
	- 本案例数据集已经相当合理，主要工作就是建模，不多赘述
	- 参考书《Python数据分析与挖掘实战》

